WITH Text_IO; USE Text_IO;
with Ada.Unchecked_Deallocation;

--
-- Implementaci de llistes utilitzant PDI
--

PACKAGE BODY TAD_llista IS

  Procedure Retorna_mem is
  new ada.Unchecked_Deallocation(object=>node, name=>punter_node);

--
-- Crear: genera una llista buida.
--

      

PROCEDURE crear_llista (ll: OUT llista) IS
BEGIN
   ll.primer:= new node;
   ll.ant:=ll.primer;
   ll.primer.seguent:=null;
   ll.total_elements:=0;
END crear_llista;


--
-- Insertar: afegeix un nou elem a la llista, si no est plena
--


PROCEDURE insertar (ll: IN OUT llista; e: IN elem) IS
aux:punter_node;
BEGIN
  aux:= new node;
  IF aux = null
       THEN RAISE mem_plena;
       ELSE       copiar_elem(e,aux.info);
                  aux.seguent := ll.ant.seguent;
                  ll.ant.seguent := aux;
                  ll.ant:= aux;
                  ll.total_elements:=ll.total_elements+1;
  END IF;

  EXCEPTION
    WHEN mem_plena => Put_Line("Error relacionat amb memoria");

END insertar;


--
-- Esborrar: elimina el element marcat pel PDI, si no est buida
--


PROCEDURE esborrar (ll: IN OUT llista) IS
aux:punter_node;
BEGIN
  aux:=ll.ant.seguent;
   IF aux = null
        THEN RAISE mem_plena;
        ELSE  ll.ant.seguent := aux.seguent;
              Retorna_mem(aux);
              ll.total_elements:=ll.total_elements-1;
   END IF;

   EXCEPTION
    WHEN mem_plena => Put_Line("Error relacionat amb memoria");

END esborrar;


--
-- Principi: accedeix al primer element de la llista, si no est buida
--


PROCEDURE principi (ll: IN OUT llista) IS
BEGIN
   ll.ant:=ll.primer;
END principi;


--
-- Consulta: retorna l'informacio de l'element marcat pel pdi
--


procedure consulta (ll: IN llista; e: out elem) IS
aux:punter_node;
BEGIN
   aux:=ll.ant.seguent;
   if aux = null
     then raise mem_plena;
   end if;
   copiar_elem(aux.info,e);

 EXCEPTION
    WHEN mem_plena => Put_Line("Error relacionat amb memoria");


END consulta;


--
-- Buida: mira si hi ha algun element a la llista
--


FUNCTION buida (ll: IN llista) RETURN Boolean IS
BEGIN
   RETURN(ll.primer.seguent=null);
END buida;


--
-- Final: mira si ens trobem al final de la llista
--


FUNCTION final (ll: IN llista) RETURN Boolean IS
BEGIN
   RETURN(ll.ant.seguent=null);
END final;


--
-- Avanar: avana la posicio del PDI
--


procedure avanar (ll: in out llista) is
begin
  if not final(ll) then
    ll.ant:=ll.ant.seguent;
  end if;
end avanar;


--
-- Num_elems: retorna el nombre d'elements de la llista
--

function num_elems (ll: in llista) return natural is

begin

   return (ll.total_elements);                            -- Retornem el contador d'elements totals que t la cua.

end num_elems;


END TAD_llista;

