--
-- Package genric de llistes
-- Parmetres: tipus d'element i funci copia.
--

GENERIC
   TYPE elem IS  PRIVATE;
   with procedure copiar_elem (e1: in elem; e2: out elem) is <>;

PACKAGE TAD_llista IS

-- El tipus s LIMITED PRIVATE per evitar que els usuaris
-- tinguin accs a la representaci interna del tipus i
-- puguin fer assignacions i comparacions.

TYPE llista IS  PRIVATE;

-- Excepcions que es poden produir

mem_plena: EXCEPTION;


-- Operacions

PROCEDURE crear_llista (ll: OUT llista);
PROCEDURE insertar (ll: IN OUT llista; e: IN elem);
PROCEDURE esborrar (ll: IN OUT llista);
PROCEDURE principi (ll: IN OUT llista);
procedure consulta (ll: IN llista; e: out elem);
Function buida (ll: IN llista) RETURN boolean;
Function final (ll: IN llista) RETURN boolean;
Procedure avanar (ll: IN OUT llista);
function num_elems (ll: in llista) return natural;


PRIVATE

--
-- La representaci del tipus sempre est a la part
-- privada, no accessible pels usuaris del tipus
--

TYPE node;

Type punter_node is access node;

TYPE node IS RECORD
   info : elem;
   seguent : punter_node;
END RECORD;

TYPE llista IS RECORD
   ant : punter_node;
   primer : punter_node;
   total_elements: natural;
END RECORD;

END TAD_llista;
